unit IndexDBGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DB, DBGrids, DBTables;

type
  TIndexDBGrid = class(TDBGrid)
  private
    { Private declarations }
    FOnTitleClick: TDBGridClickEvent;
  protected
    { Protected declarations }
    procedure TitleClick(Column: TColumn); override;
		function IsFieldIndexed(Field : TField): Boolean;
		function GetFieldIndexName(Field : TField): string;
    property OnTitleClick: TDBGridClickEvent read FOnTitleClick write FOnTitleClick;
  public
    { Public declarations }
  published
    { Published declarations }
//    property OnTitleClick;
  end;

procedure Register;

implementation

{------------------------------------------------------------------------------}
procedure TIndexDBGrid.TitleClick(Column: TColumn);
var
sFieldIndexName : string;
iIndex : Integer;
LastCursor: TCursor;
begin
sFieldIndexName := GetFieldIndexName(Column.Field);
if sFieldIndexName <> '' then
   begin
   try
     LastCursor := Screen.Cursor;
     Screen.Cursor := crHourGlass;
     TTable(Column.Field.Dataset).IndexFieldNames := sFieldIndexName;
   finally
     Screen.Cursor := LastCursor;
   end;
(*
    with TTable(Column.Field.Dataset).IndexDefs do
    begin
      iIndex := Max(IndexOf(sFieldIndexName), 0);
      if ixDescending in Items[iIndex].Options then
        FColumnSortDirection := sdDescending
      else
        FColumnSortDirection := sdAscending;
    end;
*)
   Columns.RestoreDefaults;
   Column.Title.Font.Color := clBlue;
   end;
if Assigned(FOnTitleClick) then
   begin
   FOnTitleClick(Column);
   end;
end;

{------------------------------------------------------------------------------}
function TIndexDBGrid.IsFieldIndexed(Field : TField): Boolean;
begin
Result := (TTable(Field.Dataset).IndexDefs.GetIndexForFields(Field.FieldName, False) <> nil);
end;


function TIndexDBGrid.GetFieldIndexName(Field : TField): string;
var
sFieldName  : string;
iPos        : Integer;
begin
if Field.Dataset is TTable then
   begin
   if IsFieldIndexed(Field) then
      begin
      sFieldName := TTable(Field.Dataset).IndexDefs.FindIndexForFields(Field.FieldName).Fields;
      iPos := Pos(';', sFieldName) - 1;
      if iPos > 0 then
         begin
         Result := Copy(sFieldName, 1, iPos)
         end
      else
         begin
         Result := sFieldName;
         end;
      end;
   end
else
   begin
   Result := '';
   end
end;

procedure Register;
begin
  RegisterComponents('Data Controls', [TIndexDBGrid]);
end;


end.
